import { Key } from 'react';
import { CollectionBase, Selection, Node } from '@react-types/shared';
import { MultipleSelectionStateProps } from '@react-stately/selection';
import { ListState } from '@react-stately/list';
export interface MultiSelectListProps<T> extends CollectionBase<T>, MultipleSelectionStateProps {
    filter?: (nodes: Iterable<Node<T>>) => Iterable<Node<T>>;
    suppressTextValueWarning?: boolean;
    disallowEmptySelection?: boolean;
}
export interface MultiSelectListState<T> extends ListState<T> {
    readonly selectedKeys: Selection;
    setSelectedKeys(keys: Set<Key>): void;
    readonly selectedItems: Node<T>[];
}
export declare function useMultiSelectListState<T extends object>(props: MultiSelectListProps<T>): MultiSelectListState<T>;
